with Lower_Layer_UDP;
with Ada.Streams;
with Ada.Text_IO;
with Lista; use Lista;
with Ada.Text_IO; use Ada.Text_IO;

package STCP is

   package LLU renames Lower_Layer_UDP;

   type STCP_Connection is private;

   function Open (Sending_EP   : LLU.End_Point_Type;
                  Receiving_EP : LLU.End_Point_Type;
                  Prob : integer)
                  return STCP_Connection;

   function Valida (Connection: STCP_Connection) return Boolean;

   procedure Send (Connection : STCP_Connection;
                   Raw_Data   : Ada.Streams.Stream_Element_Array);

   procedure Close (Connection: STCP_Connection);

   task type RecAck is
      entry Start (Num: integer);
      entry Stop;
   end Recack;

    tarea: RecAck;


private



   ListaPaq: L.List;

   Max_Open_Connections: constant Natural := 10;

   -- type Int_32 is mod 2**32;

   type STCP_Connection_Data is record
      Used: Boolean := False;
      Sender_EP: LLU.End_Point_Type;
      Receiver_EP: LLU.End_Point_Type;
      Next_Seq_Number: Int_32;
   end record;

   type STCP_Connection is access all STCP_Connection_Data;



end STCP;


