with Lower_Layer_UDP;
with Ada.Streams;
with Ada.Streams.Stream_IO;
with Ada.Text_IO;
with STCP;
with Ada.Command_Line;
with Ada.IO_Exceptions;
with Ada.Strings.Unbounded;

procedure Sender is

   package ASU renames Ada.Strings.Unbounded;
   package LLU renames Lower_Layer_UDP;
   package S_IO renames Ada.Streams.Stream_IO;

   Usage_Error: exception;

   Chunk_Size: constant := 1012;

   Chunk: Ada.Streams.Stream_Element_Array(1..Chunk_Size);
   Last: Ada.Streams.Stream_Element_Offset;

   Src_File: S_IO.File_Type;

   Sender_EP, Receiver_EP: Lower_Layer_UDP.End_Point_Type;
   My_Connection: STCP.STCP_Connection;

   Empezar: Boolean := False;
begin

   if Ada.Command_Line.Argument_Count /= 5 then
      raise Usage_Error;
   end if;

   Sender_EP := LLU.Build (Ada.Command_Line.Argument(2),
                           Integer'Value(Ada.Command_Line.Argument(3)));
   Receiver_EP := LLU.Build (Ada.Command_Line.Argument(2),
                             Integer'Value(Ada.Command_Line.Argument(4)));
   LLU.Bind (Sender_EP);

   S_IO.Open (Src_File, S_IO.In_File, Ada.Command_Line.Argument(1));

   My_Connection := STCP.Open (Sender_EP, Receiver_EP, Integer'Value(Ada.Command_Line.Argument(5)));
   if (STCP.Valida(My_Connection)) then

      while not S_IO.End_Of_File (Src_File) loop
         S_IO.Read (Src_File, Chunk, Last);
         STCP.Send (My_Connection, Chunk (1..Last));
      end loop;

      S_IO.Close (Src_File);
      STCP.Close (My_Connection);
   else

      Ada.Text_IO.Put_Line ("NO SE PUEDE ESTABLECER CONEXIN CON EL SERVIDOR");
      STCP.Close (My_Connection);
   end if;
   LLU.Unbind (Sender_EP);

exception
   when Usage_Error =>
      Ada.Text_IO.Put_Line ("uso: sender fichero dir_ip puerto_em puerto_rec prob_fallo");
      STCP.Close (My_Connection);
   when others =>
      Ada.Text_IO.Put_Line ("Excepcin desconocida");
end Sender;

